
sumChiSqCounts <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
		
	E <- t(matrix(as.numeric(repDataSet),nrow=length(repDataSet),ncol=nrow(randDataSets)))
	E[E==0] <- 1
	randDataSets[randDataSets==0] <- 1
	
	randchi<-((randDataSets-E)^2)/E
	distance <- rowSums(randchi)
	
	distance
}

SScounts <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	E <- t(matrix(as.numeric(repDataSet),nrow=length(repDataSet),ncol=nrow(randDataSets)))
	SS <- rowSums((randDataSets-E)^2)
	
	SS
}

SSegg <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	E <- t(matrix(as.numeric(repDataSet),nrow=length(repDataSet),ncol=nrow(randDataSets)))
	SS <- rowSums((randDataSets-E)^2)
	
	SS
}

SSimm <- function(repDataSet,randDataSets){
	
	noti<-c("I2","I3","I4","I5","I6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	E <- t(matrix(as.numeric(repDataSet),nrow=length(repDataSet),ncol=nrow(randDataSets)))
	SS <- rowSums((randDataSets-E)^2)
	
	SS
}

SSad <- function(repDataSet,randDataSets){
	
	noti<-c("A2","A3","A4","A5","A6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	E <- t(matrix(as.numeric(repDataSet),nrow=length(repDataSet),ncol=nrow(randDataSets)))
	SS <- rowSums((randDataSets-E)^2)
	
	SS
}

sumChiSqTotals <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	# specific to 6 obs times of 3 stages
	numO <- 5
	numS <- 3
	Obs <- matrix( rowSums( matrix(as.numeric(repDataSet), nrow=numO, ncol=numS) ) , nrow=numO, ncol=nrow(randDataSets) ) 
	Obs[Obs==0] <- 1

	E <- rbind(rowSums(randDataSets[,c(1,6,11)]), rowSums(randDataSets[,c(2,7,12)]), rowSums(randDataSets[,c(3,8,13)]), rowSums(randDataSets[,c(4,9,14)]), rowSums(randDataSets[,c(5,10,15)]))
	E[E==0] <- 1

	distance <- colSums( ( (Obs-E)^2 )/E )
	
	distance

}

SStotals <- function(repDataSet,randDataSets){

	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	numO <- 5
	numS <- 3
	Obs <- matrix( rowSums( matrix(as.numeric(repDataSet), nrow=numO, ncol=numS) ) , nrow=numO, ncol=nrow(randDataSets) )
	E <- rbind(rowSums(randDataSets[,c(1,6,11)]), rowSums(randDataSets[,c(2,7,12)]), rowSums(randDataSets[,c(3,8,13)]), rowSums(randDataSets[,c(4,9,14)]), rowSums(randDataSets[,c(5,10,15)]))
	
	SS <- colSums((Obs-E)^2)
	
}

SSstageRatios <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	SS <- vector(mode="numeric",length=nrow(randDataSets))
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 1/3
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 1/3
		
		diff <- randRatios-matrix( as.numeric(repRatio), nrow=nrow(randRatios), ncol=3, byrow=TRUE )

		SS <- SS + rowSums(diff^2)

	}
	
	SS
}

SSstageRatiosTrans <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	SS <- vector(mode="numeric",length=nrow(randDataSets))
	
	for (i in 1:5){
		
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 1/3
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 1/3
			
		diff <- randRatios-matrix( as.numeric(repRatio), nrow=nrow(randRatios), ncol=3, byrow=TRUE )

		SS <- SS + rowSums(asin(diff)^2)

	}
	
	SS
}


ccfTotal <- function(repDataSet,randDataSets){

	M <- nrow(randDataSets)
	
	repSums <- matrix(0, nrow=1,ncol=6)
	randSums <- matrix(0, nrow=M, ncol=6) 
	
	for (i in 1:6){		
		repSums[1,i] <- sum(as.numeric(repDataSet[1,c(i,i+6,i+12)]))
		randSums[,i] <- rowSums(randDataSets[,c(i,i+6,i+12)])
	}
	
	corrDist <- vector(mode="numeric",length=M)
	
	for (i in 1:M){
		icorr <- ccf(as.vector(repSums[,2:6], mode="numeric"), as.vector(randSums[i,2:6], mode="numeric"), plot=FALSE)		
		corrDist[i] <- icorr$acf[icorr$lag==0]
	}
	
	corrDist[is.na(corrDist)] <- 0
	distance <- 1 - corrDist
}

ccfEgg <- function(repDataSet,randDataSets){

	M <- nrow(randDataSets)
	
	repSums <- repDataSet[,1:6]
	randSums <- randDataSets[,1:6]
	
	corrDist <- vector(mode="numeric",length=M)
	for (i in 1:M){
		icorr <- ccf(as.vector(repSums[2:6], mode="numeric"), as.vector(randSums[i,2:6], mode="numeric"), plot=FALSE)		
		corrDist[i] <- icorr$acf[icorr$lag==0]
	}
	
	corrDist[is.na(corrDist)] <- 0
	distance <- 1 - corrDist
}

ccfImm <- function(repDataSet,randDataSets){

	M <- nrow(randDataSets)
	
	repSums <- repDataSet[,7:12]
	randSums <- randDataSets[,7:12]
	
	corrDist <- vector(mode="numeric",length=M)
	for (i in 1:M){
		icorr <- ccf(as.vector(repSums[2:6], mode="numeric"), as.vector(randSums[i,2:6], mode="numeric"), plot=FALSE)		
		corrDist[i] <- icorr$acf[icorr$lag==0]
	}
	
	corrDist[is.na(corrDist)] <- 0
	distance <- 1 - corrDist
}

ccfAd <- function(repDataSet,randDataSets){

	M <- nrow(randDataSets)
	
	repSums <- repDataSet[,13:18]
	randSums <- randDataSets[,13:18]
	
	corrDist <- vector(mode="numeric",length=M)
	for (i in 1:M){
		icorr <- ccf(as.vector(repSums[2:6], mode="numeric"), as.vector(randSums[i,2:6], mode="numeric"), plot=FALSE)		
		corrDist[i] <- icorr$acf[icorr$lag==0]
	}
	
	corrDist[is.na(corrDist)] <- 0
	distance <- 1 - corrDist
}

poislnP <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- repDataSet[,noti]
	randDataSets <- randDataSets[,noti]
	
	# for a data value y, the lnprob of another value k = - y +k/y
	# ranges from 0 (prob=1, good match) to - Inf (prob=0, bad match)	
	E <- t(matrix(as.numeric(repDataSet),nrow=length(repDataSet),ncol=nrow(randDataSets)))
	lnP <- -E
	E[E==0] <- 1
	randDataSets[randDataSets==0] <- 1
	lnP <- lnP + randDataSets/E
	distance <- rowSums(lnP)
	
	distance
}

KLdiv <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	# at each time we have a distribution of individuals between 3 discrete stages
	# we wish to know how different each simulated set x is from one dataset y in the distribution of individuals et each time
	# sum over 3 stages i:p(i)*ln( p(i)/q(i) ) 
	# terms where p(i)=0 do not contribute
	# distribution of representative data set = p(i)

	KL <- matrix(0,nrow=nrow(randDataSets),ncol=5)
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 1/3
		repRatios <- matrix(as.numeric(repRatio), nrow=nrow(randDataSets), ncol=3, byrow=TRUE)
		
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 1/3
		
		div <- repRatios*log(repRatios/randRatios)
		div[is.na(div)] <- 0
		for (j in 1:3){div[is.infinite(div[,j]),j]<-0}
		
		KL[,i] <- rowSums(div)
		### issue: allows negative values
	}
	
	distance <- rowSums(KL)
	
	distance
}

SSKLdiv <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	# at each time we have a distribution of individuals between 3 discrete stages
	# we wish to know how different each simulated set x is from one dataset y in the distribution of individuals et each time
	# sum over 3 stages i:p(i)*ln( p(i)/q(i) ) 
	# terms where p(i)=0 do not contribute
	# distribution of representative data set = p(i)

	KL <- data.frame(matrix(0,nrow=nrow(randDataSets),ncol=5))
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 1/3
		repRatios <- matrix(as.numeric(repRatio), nrow=nrow(randDataSets), ncol=3, byrow=TRUE)
		
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 1/3
		
		div <- repRatios*log(repRatios/randRatios)
		div[is.na(div)] <- 0
		for (j in 1:3){div[is.infinite(div[,j]),j]<-0}
		
		KL[,i] <- rowSums(div)
		### issue: allows negative values
	}
	
	distance <- rowSums(KL^2)
	
	distance
}


BhattDist <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	# at each time we have a distribution of individuals between 3 discrete stages
	# we wish to know how different each simulated set x is from one dataset y in the distribution of individuals et each time
	# sum over 3 stages i:p(i)*ln( p(i)/q(i) ) 
	# terms where p(i)=0 do not contribute
	# distribution of representative data set = p(i)

	bhatt <- matrix(0,nrow=nrow(randDataSets),ncol=5)
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 0
		repRatios <- matrix(as.numeric(repRatio), nrow=nrow(randDataSets), ncol=3, byrow=TRUE)
		
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 0
		
		bhatt[,i]<- -log(rowSums(sqrt(repRatios*randRatios)))
		
	}
	
	distance <- rowSums(bhatt)
	
	distance
}


HellDist <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	# at each time we have a distribution of individuals between 3 discrete stages
	# we wish to know how different each simulated set x is from one dataset y in the distribution of individuals et each time
	# sum over 3 stages i:p(i)*ln( p(i)/q(i) ) 
	# terms where p(i)=0 do not contribute
	# distribution of representative data set = p(i)

	hell <- matrix(0,nrow=nrow(randDataSets),ncol=5)
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 0
		repRatios <- matrix(as.numeric(repRatio), nrow=nrow(randDataSets), ncol=3, byrow=TRUE)
		
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 0
		
		hell[,i]<- sqrt(rowSums((sqrt(repRatios)-sqrt(randRatios))^2))/sqrt(2)		
	}
	
	distance <- rowSums(hell)
	
	distance
}

SSHellDist <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	# at each time we have a distribution of individuals between 3 discrete stages
	# we wish to know how different each simulated set x is from one dataset y in the distribution of individuals et each time
	# sum over 3 stages i:p(i)*ln( p(i)/q(i) ) 
	# terms where p(i)=0 do not contribute
	# distribution of representative data set = p(i)

	hell <- matrix(0,nrow=nrow(randDataSets),ncol=5)
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 0
		repRatios <- matrix(as.numeric(repRatio), nrow=nrow(randDataSets), ncol=3, byrow=TRUE)
		
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 0
		
		hell[,i]<- sqrt(rowSums((sqrt(repRatios)-sqrt(randRatios))^2))/sqrt(2)		
	}
	
	distance <- rowSums(hell^2)
	
	distance
}

EMD <- function(repDataSet,randDataSets){
	
	noti<-c("E2","E3","E4","E5","E6","I2","I3","I4","I5","I6","A2","A3","A4","A5","A6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	# at each time we have a distribution of individuals between 3 discrete stages
	# we wish to know how different each simulated set x is from one dataset y in the distribution of individuals et each time
	# sum over 3 stages i:p(i)*ln( p(i)/q(i) ) 
	# terms where p(i)=0 do not contribute
	# distribution of representative data set = p(i)

	emd <- matrix(0,nrow=nrow(randDataSets),ncol=5)
	
	for (i in 1:5){
	
		repRatio <- repDataSet[c(i,i+5,i+10)] / sum(repDataSet[c(i,i+5,i+10)])
		repRatio[is.na(repRatio)] <- 1/3
		repRatios <- matrix(as.numeric(repRatio), nrow=nrow(randDataSets), ncol=3, byrow=TRUE)
		
		randRatios <- randDataSets[,c(i,i+5,i+10)] / rowSums(randDataSets[,c(i,i+5,i+10)])
		randRatios[is.na(randRatios)] <- 1/3
		
		dirt <- randRatios-repRatios
		dirt <- data.frame(dirt)
		colnames(dirt)<-c("e","i","a")
		
		dirt$i[dirt$e>0]<-dirt$i[dirt$e>0]+dirt$e[dirt$e>0]
		emd[dirt$e>0,i] <- emd[dirt$e>0,i]+dirt$e[dirt$e>0]
		dirt$e[dirt$e>0] <- 0
		
		dirt$i[dirt$a>0]<-dirt$i[dirt$a>0]+dirt$a[dirt$a>0]
		emd[dirt$a>0,i] <- emd[dirt$a>0,i]+dirt$a[dirt$a>0]
		dirt$a[dirt$a>0] <- 0
		
		dirt$i[dirt$e<0]<-dirt$i[dirt$e<0]+dirt$e[dirt$e<0]
		emd[dirt$e<0,i] <- emd[dirt$e<0,i]-dirt$e[dirt$e<0]
		dirt$e[dirt$e<0] <- 0
		
		dirt$i[dirt$a<0]<-dirt$i[dirt$a<0]+dirt$a[dirt$a<0]
		emd[dirt$a<0,i] <- emd[dirt$a<0,i]-dirt$a[dirt$a<0]
		dirt$a[dirt$a<0] <- 0
		
	}
	
	distance <- rowSums(emd)
	
	distance
}

SSnewEggs <- function(repDataSet,randDataSets){
	
	noti<-c("E1","E2","E3","E4","E5","E6")
	repDataSet <- as.vector(repDataSet[,noti],mode="double")
	randDataSets <- randDataSets[,noti]
	
	repSet<- repDataSet[2:6]-repDataSet[1:5]
	repSet[repSet<0] <- 0
	EnewEggs <- t(matrix(as.numeric(repSet), nrow=length(repSet), ncol=nrow(randDataSets)))
	
	newEggs <- randDataSets[,2:6]-randDataSets[,1:5]
	newEggs[newEggs<0] <- 0
	
	SS <- rowSums((newEggs-EnewEggs)^2)
	
	SS
}

SSeggRate <- function(repDataSet,randDataSets){
	
	adi<-c("A1","A2","A3","A4","A5")
	repAd <- as.vector(repDataSet[,adi],mode="double")
	repAd[repAd==0] <- 0.1
		
	repDataSet <- as.vector(repDataSet,mode="double")
	repSet<- repDataSet[2:6]-repDataSet[1:5]
	repSet[repSet<0] <- 0	
	
	Erate <- repSet/repAd
	
	E <- t(matrix(as.numeric(Erate), nrow=length(Erate), ncol=nrow(randDataSets)))
	
	newEggs <- randDataSets[,2:6]-randDataSets[,1:5]
	newEggs[newEggs<0] <- 0
	randAds<-randDataSets[,adi]
	randAds[randAds==0] <- 0.1
	Obs <- newEggs/randAds
	
	SS <- rowSums((Obs-E)^2)
	
	SS
}
